=== debian/changelog ===
mrpt (1:1.3.0-1build1) wily; urgency=medium

  * No-change rebuild against libwx*-0v5

 -- Martin Pitt <martin.pitt@ubuntu.com>  Mon, 10 Aug 2015 12:30:54 +0200

mrpt (1:1.3.0-1) unstable; urgency=medium

  * New version of upstream sources.
  * Update Debian standards version (3.9.6)
  * Fix Lintian warnings (`desktop-mime-but-no-exec-code`)

 -- Jose Luis Blanco (University of Malaga) <joseluisblancoc@gmail.com>  Sun, 18 Jan 2015 01:33:07 +0100
